<template>
  <v-layout class="word-chips" align-center>
    <v-chip
      :outline="isVocabulary"
      label
      :text-color="textColor"
      :class="{'word-chips__line-through' : !isKeyword}"
      :color="backgroundColor"
    >{{sentence}}</v-chip>
    <!-- ARROW  -->
    <v-icon v-if="!isKeyword && replacements.length > 0">arrow_forward</v-icon>
    <!-- LIST -->
    <v-layout v-if="!isKeyword" class="word-chips__list">
      <v-chip
        label
        text-color="white"
        color="#8bc34a"
        v-for="(item, index) in replacements"
        :key="index"
      >{{item.value}}</v-chip>
    </v-layout>
  </v-layout>
</template>

<script>
export default {
  props: {
    content: {
      type: Object,
      default: () => {},
    },
  },
  computed: {
    backgroundColor() {
      const colors = {
        red: this.isKeyword,
        black: this.isVocabulary,
        transparent: !this.isKeyword && !this.isVocabulary,
      };
      return Object.keys(colors).filter(it => colors[it])[0];
    },
    textColor() {
      return this.isKeyword ? 'white' : 'black';
    },
    isKeyword() {
      return this.content.rule === 'KEYWORD';
    },
    isVocabulary() {
      return this.content.rule === 'VOCABULARY';
    },
    sentence() {
      return this.content.sentence;
    },
    replacements() {
      return this.content.replacements ? this.content.replacements : [];
    },
  },
};
</script>

<style lang="sass">
  .word-chips
    text-transform: lowercase
    overflow: hidden
    &::after
      content: ' '
      width: 15%
      height: 40px
      position: absolute
      background-image: linear-gradient(to left, rgba(255, 255, 255, 0.9),
      rgba(255, 255, 255, 0.8), rgba(255, 255, 255, 0.5), rgba(255, 255, 255, 0.1))
      right: 0
      display: block
    &__list
      white-space: nowrap
    &__line-through
      text-decoration: line-through
    &::first-letter
        text-transform: uppercase
</style>
